cdef extern from "openssl/evp.h":
    bint PKCS5_PBKDF2_HMAC_SHA1(char *password, int passlen,
                                unsigned char *salt, int saltlen,
                                int iter, int keylen,
                                unsigned char *buffer_out)

cdef extern from "string.h":
    char *strncpy(char *dest, char *src, int n)

cdef extern from "mcrypt.h":
    cdef struct CRYPT_STREAM:
        pass

    # Generic high-level functions.
    CRYPT_STREAM *mcrypt_module_open(char* algorithm, char* a_dir,
                                     char* mode, char* m_dir)
    int mcrypt_module_close(CRYPT_STREAM *td)
    bint mcrypt_module_support_dynamic()

    # Open/close functions which, best as I can tell, are not
    # used anymore.
    int mcrypt_generic_init(CRYPT_STREAM *td, void *key,
                            int lenofkey, void *IV)
    int mcrypt_generic_deinit(CRYPT_STREAM *td)
    int mcrypt_generic_end(CRYPT_STREAM *td)

    # Encrypt/decrypt functions.
    int mdecrypt_generic(CRYPT_STREAM *td, void *plaintext, int len)
    int mcrypt_generic(CRYPT_STREAM *td, void *plaintext, int len)

    # Extra functions.
    int mcrypt_enc_set_state(CRYPT_STREAM *td, void *st, int size)
    int mcrypt_enc_get_state(CRYPT_STREAM *td, void *st, int size)
    int mcrypt_enc_self_test(CRYPT_STREAM *td)
    int mcrypt_enc_get_block_size(CRYPT_STREAM *td)
    int mcrypt_enc_get_iv_size(CRYPT_STREAM *td)
    int mcrypt_enc_get_key_size(CRYPT_STREAM *td)

    bint mcrypt_enc_is_block_algorithm(CRYPT_STREAM *td)
    bint mcrypt_enc_is_block_mode(CRYPT_STREAM *td)
    bint mcrypt_enc_is_block_algorithm_mode(CRYPT_STREAM *td)
    bint mcrypt_enc_mode_has_iv(CRYPT_STREAM *td)

    char *mcrypt_enc_get_algorithms_name(CRYPT_STREAM *td)
    char *mcrypt_enc_get_modes_name(CRYPT_STREAM *td)

    int *mcrypt_enc_get_supported_key_sizes(CRYPT_STREAM *td, int *len)

    char **mcrypt_list_algorithms(char *libdir, int *size)
    char **mcrypt_list_modes(char *libdir, int *size)

    void mcrypt_free_p(char **p, int size)
    void mcrypt_free(void *ptr)

    void mcrypt_perror(int err)
    char *mcrypt_strerror(int err)

    int mcrypt_module_self_test(char *algo, char *algo_dir)
    int mcrypt_module_is_block_algorithm(char *algo, char *algo_dir)
    int mcrypt_module_is_block_algorithm_mode(char *algo, char *algo_dir)
    int mcrypt_module_is_block_mode(char *mode, char *mode_dir)
    int mcrypt_module_get_algo_key_size(char *algo, char *algo_dir)
    int mcrypt_module_get_algo_block_size(char *algo, char *algo_dir)
    int mcrypt_module_get_algo_supported_key_sizes(char *algo, char *algo_dir)

    int mcrypt_module_algorithm_version(char *algo, char *algo_dir)
    int mcrypt_module_mode_version(char *mode, char *mode_dir)

    # TODO: mcrypt_mutex_register

    char *mcrypt_check_version(char *ver)
