from distutils.core import setup
from distutils.extension import Extension
from textwrap import wrap

setup(name = 'pymcrypt',
      version = '0.0.1',
      ext_modules = [ Extension('pymcrypt.libmcrypt', ['libmcrypt.c'],
                                libraries = ['mcrypt']) ],
      author = 'Michael B. Trausch',
      author_email = 'mike@trausch.us',
      url = 'https://launchpad.net/pymcrypt',
      license = 'GPLv3',
      packages = [ 'pymcrypt' ],
      py_modules = [ 'pymcrypt.EncryptedWriter', 'pymcrypt.__init__',
                     'pymcrypt.EncryptedReader', 'pymcrypt.common' ],
      data_files = [ ('cmcrypt', [ 'cmcrypt.pxd', 'libmcrypt.pyx' ]) ],
      description = 'mcrypt extension for Python 2 and 3',
      long_description = '\n'.join(wrap('''This package provides for a (hopefully)
clean, simple wrapper around mcrypt that can be used from both Python
2 and Python 3 code.  It is presently not yet stable, and it can be expected
that the interface will not be stable until at least a few versions from now;
it will definitely be stable by 1.0, but it is hoped way before then.''')),
      platforms = [ 'posix' ])
